#ifndef EFL_GENERATED_ECORE_PARENT_HH
#define EFL_GENERATED_ECORE_PARENT_HH

extern "C"
{
#include <Efl.h>
}
#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "ecore_parent.eo.h"
}


namespace ecore {

struct parent
      : efl::eo::base
{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit parent(Eo* eo)
      : efl::eo::base(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit parent(std::nullptr_t)
      : efl::eo::base(nullptr)
   {}

   /// @brief Copy Constructor.
   ///
   parent(parent const& other)
      : efl::eo::base(eo_ref(other._eo_ptr()))
   {}

   ~parent() {}

   static Eo_Class const* _eo_class()
   {
      return(ECORE_PARENT_CLASS);
   }

private:
};
} 

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ecore::parent >
{
   template <typename T>
   struct type
   {
   };
};


template<>
struct operation_description_class_size< ecore::parent >
{
   static const int value = 0;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<ecore::parent>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   return 0;
}
inline void
call_constructor(tag< ecore::parent >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<ecore::parent, ::std::tuple<efl::eo::parent_type> > const& args)
{
   eo_do_super(eo, cls, ::eo_constructor());
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

template<>
struct extension_inheritance< ecore::parent>
{
   template <typename U>
   struct type
   {
      operator ecore::parent() const
      {
         return ecore::parent(eo_ref(static_cast<U const*>(this)->_eo_ptr()));
      }

   };
};

inline Eo_Class const* get_eo_class(tag<ecore::parent>)
{
   return (ECORE_PARENT_CLASS);
}

} } }
#endif // EFL_GENERATED_ECORE_PARENT_HH

